/*
 * Copyright (C) 2001,2002 Wojciech Purczynski <cliph@isec.pl>
 *
 * THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
 * IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
 * THE FREE SOFTWARE  FOUNDATION;  EITHER  VERSION 2 OF THE LICENSE, OR
 * (AT YOUR OPTION) ANY LATER VERSION.
 *
 * THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL,
 * BUT WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED  WARRANTY OF
 * MERCHANTABILITY OR FITNESS  FOR A PARTICULAR  PURPOSE.  SEE THE
 * GNU GENERAL PUBLIC LICENSE FOR MORE DETAILS.
 */

#ifndef _CAPSEL_DEV_H
#define _CAPSEL_DEV_H

#define CAPSEL_MAJOR	240
#define CAPSEL_DEV	"capsel"
#define CAPSELVERMAX	4095

#define CAPSELIOCTL	0xdefaced
/* read module version string */
#define CAPSELVERSION	(CAPSELIOCTL+1)
/* flushes all rules - it disables capsel */
#define CAPSELFLUSH	(CAPSELIOCTL+2)
/* creates new empty list of rules */
#define CAPSELNEW	(CAPSELIOCTL+3)
/* adds rule to list */
#define CAPSELADD   	(CAPSELIOCTL+4)
/* adds default rule */
#define CAPSELADDDEF	(CAPSELIOCTL+5)
/* install new list */
#define CAPSELINSTALL	(CAPSELIOCTL+6)
/* show configuration information */
#define CAPSELSTATUS	(CAPSELIOCTL+7)

typedef struct capsel_status_t {
	unsigned count;
	unsigned size;
	int default_rule;
} capsel_status_t;

#define VERSION_STRING	NAME "-" VERSION

#ifdef __KERNEL__
int capsel_ioctl_init(void);
void capsel_ioctl_cleanup(void);
#endif /* __KERNEL__ */

#endif

