/*
 * Copyright (C) 1999-2002 Wojciech Purczynski <cliph@isec.pl>
 *
 * THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
 * IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
 * THE FREE SOFTWARE  FOUNDATION;  EITHER  VERSION 2 OF THE LICENSE, OR
 * (AT YOUR OPTION) ANY LATER VERSION.
 *
 * THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL,
 * BUT WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED  WARRANTY OF
 * MERCHANTABILITY OR FITNESS  FOR A PARTICULAR  PURPOSE.  SEE THE
 * GNU GENERAL PUBLIC LICENSE FOR MORE DETAILS.
 */

#include <linux/config.h>

#if CONFIG_MODVERSIONS
#include <linux/modversions.h>
#endif

#include <linux/module.h>

#include <linux/kernel.h>
#include <asm/system.h>

#include "config.h"
#include "ioctl.h"
#include "sys.h"
#include "sys.h"
#include "arch.h"

#ifndef MODULE_LICENSE
#define MODULE_LICENSE(license)
#endif

MODULE_AUTHOR("Copyright (c) 1999-2002 by Wojciech Purczynski <cliph@isec.pl>");
MODULE_DESCRIPTION("capsel - Linux kernel 2.2.x/2.4.x security module"); 
MODULE_LICENSE("GPL");
char kernel_version[]=UTS_RELEASE;

EXPORT_NO_SYMBOLS;

/*** init_module ***/
int init_module(void)
{
	int error;
	unsigned long flags;

	save_flags(flags);
	cli();
	
	error=capsel_ioctl_init();

	if (!error) {
		install_hook(sys_hooks);
		install_hook(arch_hooks);
		printk(KERN_INFO NAME " module " VERSION " installed\n");
	}
	
	restore_flags(flags);

	return error;
} /* init_module */

void cleanup_module(void)
{
	unsigned long flags;

	save_flags(flags);
	cli();

	capsel_ioctl_cleanup();
	uninstall_hook(arch_hooks);
	uninstall_hook(sys_hooks);

	restore_flags(flags);
	rule_free_all();

	printk(KERN_INFO NAME " module " VERSION " uninstalled\n");
} /* cleanup_module */
